#include <bits/stdc++.h>

using namespace std;
#define int long long

const int mod = (int) 1e9 + 7;

const int N = (int) 1e6 * 2 + 10;

int f[N], invf[N];

int binpow(int x, int n) {
    if (n == 0) return 1;
    if (n == 1) return x;
    if (n % 2 == 0)
        return binpow((x * x) % mod, n / 2);
    return (x * binpow((x * x) % mod, n / 2)) % mod;
}

int inv(int x) {
    return binpow(x, mod - 2);
}

int cnk(int n, int k) {
    return ((f[n] * invf[k]) % mod * invf[n - k]) % mod;
}

int cat[N];

int cnt(int x) {
    return cat[x];
}

int add(int x, int y) {
    return cnk(x + y, y);
}

int calc(int a, int b, int c, int d) {
    if (c < d) return 0;
    int res = cnt(d);
    res = (res * add(2 * d, a)) % mod;
    res = (res * add(2 * d + a, b)) % mod;
    return res;
}


int dp[110][110][110], sum[110][110][110];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    int n, m, k, res = 0;
    cin >> n >> m >> k;
    if (n <= 100 && m <= 100 && k <= 100) {
        vector<pair<int, int> > a(k);
        for (int i = 0; i < k; i++) cin >> a[i].first >> a[i].second;
        vector<int> y[n], x[m];
        for (int i = 0; i < k; i++) y[a[i].first - 1].emplace_back(a[i].second - 1);
        for (int i = 0; i < k; i++) x[a[i].second - 1].emplace_back(a[i].first - 1);
        for (int i = 0; i < n; i++) sort(y[i].begin(), y[i].end());
        for (int i = 0; i < m; i++) sort(x[i].begin(), x[i].end());
        for (int j = 0; j < m; j++) dp[0][0][j] = 1;
        for (int j2 = 0; j2 < m; j2++) {
            for (int j1 = 0; j1 <= j2; j1++)
                sum[0][j1][j2] = ((j1 > 0 ? sum[0][j1 - 1][j2] : 0) + dp[0][j1][j2]) % mod;
        }
        for (int i = 1; i < n; i++) {
            for (int p = 0; p < m; p++) {
                for (int q = p + 1; q < m; q++) {
                    int r1, r2, ind = upper_bound(y[i].begin(), y[i].end(), p) - y[i].begin();
                    if (ind >= y[i].size() || y[i][ind] > q) r2 = q;
                    else r2 = y[i][ind];
                    if (y[i].empty() || y[i][0] > p) r1 = p;
                    else r1 = y[i][0];
                    for (int j2 = q; j2 > p; j2--) {
                        if (j2 <= r2) {
                            dp[i][p][q] = (dp[i][p][q] + sum[i - 1][min(r1, j2 - 1)][j2]);
                            // for (int j1 = j2 - 1; j1 >= 0; j1--) {
                            //     if (j1 > r1) continue;
                            //     dp[i][p][q] = (dp[i][p][q] + dp[i - 1][j1][j2]) % mod;
                            // }
                        }
                        if (!x[j2].empty() && x[j2][0] < i) break;
                    }
                }
            }
            for (int q = 0; q < m; q++) {
                for (int p = 0; p <= q; p++)
                    sum[i][p][q] = ((p > 0 ? sum[i][p - 1][q] : 0) + dp[i][p][q]) % mod;
            }
        }
        int res = 0;
        for (int i = m - 1; i >= 0; i--) {
            if (!y[n - 1].empty() && i > y[n - 1][0]) continue;
            res = (res + dp[n - 2][i][m - 1]) % mod;
        }
        cout << (res * 2) % mod;
        return 0;
    }

    f[0] = 1;
    for (int i = 1; i < N; i++) f[i] = (f[i - 1] * i) % mod;
    for (int i = 0; i < N; i++) invf[i] = inv(f[i]);

    cat[0] = 1;
    cat[1] = 1, cat[2] = 2;
    for (int i = 3; i < N / 2; i++) {
        cat[i] = (cnk(2 * i, i) * inv(i + 1)) % mod;
    }
    for (int a1 = 0; a1 <= n - 1; a1++) {
        int a3 = n - 1 - a1, a4 = n - 1 - a1;
        int a2 = (2 * (m - 1) - a3 - a4) / 2;
        if (a3 <= 0 || a4 <= 0 || a2 < 0 || (a1 + a3) != n - 1 || (a1 + a4) != n - 1 ||
            (a2 + a3) != m - 1 || (a2 + a4) != m - 1)
            continue;
        a3--, a4--;
        res = (res + calc(a1, a2, a3, a4)) % mod;
    }
    cout << (res * 2) % mod;
    return 0;
}
