#include <bits/stdc++.h>

using namespace std;
#define int long long

const int mod = (int) 1e9 + 7;

const int N = (int) 1e6 * 5 + 10;

int f[N];

int binpow(int x, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0)
        return binpow((x * x) % mod, n / 2);
    return (x * binpow((x * x) % mod, n / 2)) % mod;
}

int inv(int x) {
    return binpow(x, mod - 2);
}

int cnk(int n, int k) {
    return ((f[n] * inv(f[k])) % mod * inv(f[n - k])) % mod;
}

int cat[N];

int cnt(int x) {
    return cat[x];
}

int add(int x, int y) {
    return cnk(x + y, y);
}

int calc(int a, int b, int c, int d) {
    if (c < d) return 0;
    int res = cnt(d);
    res = (res * add(2 * d, a)) % mod;
    res = (res * add(2 * d + a, b)) % mod;
    res = (res * add(2 * d + a + b, c - d)) % mod;
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    cat[0] = 1;
    cat[1] = 1, cat[2] = 2;
    for (int i = 3; i < 1000; i++) {
        cat[i] = cat[i - 1];
        for (int j = 1; j < i; j++) {
            cat[i] = (cat[i] + cat[j - 1] * cat[i - j]) % mod;
        }
    }

    f[0] = 1;
    for (int i = 1; i < N; i++) f[i] = (f[i - 1] * i) % mod;

    int n, m, k, res = 0;
    cin >> n >> m >> k;
    for (int a1 = 0; a1 <= n - 1; a1++) {
        int a3 = n - 1 - a1, a4 = n - 1 - a1;
        if ((2 * (m - 1) - a3 - a4) % 2 != 0) continue;
        int a2 = (2 * (m - 1) - a3 - a4) / 2;
        if (a3 <= 0 || a4 <= 0 || a2 + a4 != m - 1 || a2 + a3 != m - 1) continue;
        if (a2 < 0) continue;
        a3--, a4--;
        res = (res + calc(a1, a2, a3, a4)) % mod;
    }
    cout << res;
    return 0;
}
