#include <bits/stdc++.h>

using namespace std;
#define int long long

void read(deque<int> &s) {
    string t;
    cin >> t;
    for (auto c: t) s.emplace_back(c - '0');
}

vector<int> p = {2, 3, 5, 7};

int calc(deque<int> l, deque<int> r, int pref) {
    int sz = (int) l.size();
    vector<vector<bool> > prL(sz), prR(sz), sufL(sz), sufR(sz);
    for (int i = 0; i < sz; i++)
        prL[i].resize(3, false), prR[i].resize(3, false), sufL[i].resize(3, false), sufR[i].resize(3, false);
    for (int i = 0; i < sz; i++) {
        vector<bool> last(3, false);
        if (i == 0) last[1] = true;
        else last = prL[i - 1];
        if (last[0]) prL[i] = {true, false, false};
        else if (last[1]) prL[i] = {(l[i] > 1), (l[i] == 1), (l[i] < 1)};
        else if (last[2]) prL[i] = {false, false, true};
        fill(last.begin(), last.end(), false);
        if (i == 0) last[1] = true;
        else last = prR[i - 1];
        if (last[0]) prR[i] = {true, false, false};
        else if (last[1]) prR[i] = {(r[i] > 1), (r[i] == 1), (r[i] < 1)};
        else if (last[2]) prR[i] = {false, false, true};
    }
    for (int i = sz - 1; i >= 0; i--) {
        vector<bool> last(3, false);
        if (i == sz - 1) last[1] = true;
        else last = sufL[i + 1];
        if (l[i] > 1) sufL[i] = {true, false, false};
        else if (l[i] == 1) sufL[i] = last;
        else sufL[i] = {false, false, true};
        fill(last.begin(), last.end(), false);
        if (i == sz - 1) last[1] = true;
        else last = sufR[i + 1];
        if (r[i] > 1) sufR[i] = {true, false, false};
        else if (r[i] == 1) sufR[i] = last;
        else sufR[i] = {false, false, true};
    }
    int cnt = 0;
    for (int i = 0; i < sz; i++) {
        for (auto pr: p) {
            if ((i > 0 && prL[i - 1][2]) || ((i == 0 || prL[i - 1][1]) &&
                                             pr > l[i]) || ((i == 0 || prL[i - 1][1]) && pr == l[i] && (i == sz - 1 ||
                                                                (sufL[i + 1][2] || sufL[i + 1][1])))) {
                if ((i > 0 && prR[i - 1][0]) || ((i == 0 || prR[i - 1][1]) &&
                                                 pr < r[i]) || (
                        (i == 0 || prR[i - 1][1]) && pr == r[i] && (
                            i == sz - 1 || (sufR[i + 1][0] || sufR[i + 1][1])))) {
                    cnt = cnt + (pref == -1 ? 1 : min(i + 1, pref));
                }
            }
        }
    }
    return cnt;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    deque<int> l, r;
    read(l), read(r);
    int res = 0;
    if (l.size() < r.size()) {
        deque<int> tmp(l.size(), 9);
        res += calc(l, tmp, -1);
    }
    deque<int> tmp;
    if (l.size() == r.size()) tmp = l;
    else {
        tmp.emplace_back(1);
        for (int i = 0; i < r.size() - 1; i++) tmp.emplace_back(0);
    }
    res += calc(tmp, r, -1);
    if (l.size() + 1 < r.size()) {
        int dif = (int) r.size() - 1 - (int) l.size();
        while (l.size() < r.size() - 1) l.push_front(0);
        for (int i = 0; i < r.size(); i++) r[i] = 9;
        r.pop_front();
        res += calc(l, r, dif);
    }
    cout << res;
    return 0;
}
